                        .586p
                        .model  flat, stdcall
                        locals
                        jumps

include                 c:\tasm32\include\shitheap.inc
include                 apimacro.mac
include                 ring0.inc
     
                        .data
driver:                 unis    <\Device\ring0>
symlink:                unis    <\??\ring0>
driver_us               unicode_string <0>
sym_us                  unicode_string <0>
pdeviceobject           dd      ?
mdlh                    dd      ? 

                        .code
                        public  C start
                        
start:                  ;[ebp+8] pDriverObject [ebp+0ch] pRegPatch
                        push    ebp
                        mov     ebp, esp
                        pusha
                        
                        push    offset driver
                        push    offset driver_us
                        iWin32  RtlInitUnicodeString
                        
                        push    offset pdeviceobject
                        push    0
                        push    0
                        push    FILE_DEVICE_UNKNOWN
                        push    offset driver_us
                        push    0
                        push    dword ptr[ebp+8]
                        iWin32  IoCreateDevice
                        test    eax, eax
                        jnz     __failinit
                        
                        push    offset symlink
                        push    offset sym_us
                        iWin32  RtlInitUnicodeString
                        
                        push    offset driver_us
                        push    offset sym_us
                        iWin32  IoCreateSymbolicLink
                        test    eax, eax
                        jnz     __deletedevice
                        
                        mov     eax, [ebp+8]                    ;pDriverObject

                        mov     [eax.dro_majorfunctions.irp_mj_create], offset RequestHandler     
                        mov     [eax.dro_majorfunctions.irp_mj_close], offset RequestHandler     
                        mov     [eax.dro_majorfunctions.irp_mj_device_control], offset ServiceHandler     
                        mov     [eax.dro_DriverUnload], offset DriverUnload                              
                                                
                        xor     eax, eax
                        jmp     __exitinit                        
                        
__deletedevice:         push    pdeviceobject
                        iWin32  IoDeleteDevice      
                        
__failinit:             mov     eax, 1
                        
__exitinit:             mov     [esp.Pushad_eax], eax
                        popa
                        pop     ebp
                        retn    8
                        
RequestHandler:         ;[esp+4] pDeviceObject, [esp+8] pIrp
                        mov     ecx, [esp+8]
                        mov     [ecx.irp_iostatus.iob_status], 0
                        mov     [ecx.irp_iostatus.iob_information], 0
                        xor     edx, edx
                        iWin32  IofCompleteRequest
                        xor     eax, eax
                        retn    8

DriverUnload:           ;pDriverObject  [esp+4]                        
                        push    offset sym_us
                        iWin32  IoDeleteSymbolicLink

                        mov     eax, [esp+4]
                        push    [eax.dro_deviceobject]
                        iWin32  IoDeleteDevice
                        retn    4

ServiceHandler:         ;[ebp+8] pDeviceObject, [ebp+0ch] pIrp
                        push    ebp
                        mov     ebp, esp
                        pusha
                        
                        mov     ebx, [ebp+0ch]  ;pIrp
                        mov     edx, [ebx.irp_tail.t_CurrentStackLocation]  
                        
                        cmp     [edx.isl_IoControlCode], 10h
                        jne     __sh_fail

                        mov     eax, [ebx.irp_systembuffer]
                        
                        cmp     [eax], 'HOOK'
                        je      __hook
                        cmp     [eax], 'UNHO'
                        jne     __sh_fail
                        
                        cmp     hooked, 0
                        je      __sh_fail
                        
                        iMOV    esi, KeServiceDescriptorTable
                        mov     esi, [esi]
                        mov     eax, servicenumber
                        mov     ebx, old_NtQuerySystemInformation
                        
                        mov     edx, cr0
                        and     edx, 0FFFEFFFFh
                        mov     cr0, edx
                        
                        mov     [esi+eax*4], ebx
                        
                        or      edx, 10000h
                        mov     cr0, edx
                        mov     hooked, 0
                        jmp     __sh_oki
                        
__hook:                 cmp     hooked, 1
                        je      __sh_fail
                        
                        iMOV    esi, KeServiceDescriptorTable
                        mov     eax, [eax+4]
                        mov     servicenumber, eax      
                        mov     esi, [esi]                       
                
                        mov     ebx, [esi+eax*4]
                
                        mov     old_NtQuerySystemInformation, ebx
                        
                        mov     ebx, offset New_NtQuerySystemInformation
                        
                        mov     edx, cr0
                        and     edx, 0FFFeFFFFh
                        mov     cr0, edx
                        
                        mov     [esi+eax*4], ebx
                        
                        or      edx, 10000h
                        mov     cr0, edx
                        
                        mov     hooked, 1
                                                                        
__sh_oki:               mov     ecx, [ebp+0ch]
                        xor     edx, edx
                        iWin32  IofCompleteRequest
                        xor     eax, eax
                        jmp     __sh_exit
                        
__sh_fail:              mov     ecx, [ebp+0ch]
                        xor     edx, edx
                        iWin32  IofCompleteRequest                       
                        mov     eax, 1            
                                    
__sh_exit:              mov     [esp.Pushad_eax], eax
                        popa
                        pop     ebp
                        retn    8                        

servicenumber           dd      ?
hooked                  dd      ?
old_NtQuerySystemInformation    dd      ?

New_NtQuerySystemInformation    proc
                        arg     systeminformationclass
                        arg     systeminformation
                        arg     systeminformationsize
                        arg     requiredsize
                                               
                        push    requiredsize
                        push    systeminformationsize
                        push    systeminformation
                        push    systeminformationclass
                        call    dword ptr[old_NtQuerySystemInformation]
                        test    eax, eax
                        jnz     __error
                        
                        cmp     systeminformationclass, 0bh
                        jne     __error
                        
                        pusha
                        mov     esi, systeminformation
                        mov     ecx, [esi]
                        add     esi, 4
                        
__cycle_modules:        lea     ebx, [esi.smi_imagename]
                        movzx   eax, [esi.smi_modulenameoffset]
                        add     ebx, eax
                        cmp     [ebx], 'ciTN'
                        je      __change
                        cmp     [ebx], 'DisO'
                        je      __change
                        cmp     [ebx], 'vwis'
                        je      __change
                        cmp     [ebx], 'htpc'
                        jne     __next_module

__change:               mov     [ebx], 'ison'
                        
__next_module:
                        add     esi, size system_module_information                       
                        loop    __cycle_modules
                        
                        popa
__error:                leave
                        retn    10h  
                        endp
                                         
end                     start



